Hooks:Add("LocalizationManagerPostInit", "ca_hit_flash_loc", function(...)		
	LocalizationManager:add_localized_strings({
		menu_ca_hitflash = "Chromatic Aberration Hit Flash",
		ca_default_value = "Static Aberration",
		ca_default_value_desc = "Default amount of abberation on the screen.",
		ca_duration = "Duration",
		ca_duration_desc = "Duration of hit flash.",
		ca_amount = "Width",
		ca_amount_desc = "Width of hit flash.",
		ca_on_suppression = "Suppression",
		ca_on_armor_damage = "Armor Damage",
		ca_on_health_damage = "Health Damage",
		ca_on_suppression_desc = "Hit flash on enemy suppresion fire.",
		ca_on_armor_damage_desc = "Hit flash on armor damage.",
		ca_on_health_damage_desc = "Hit flash on health damage.",
	})
	
	if Idstring("schinese"):key() == SystemInfo:language():key() then
		LocalizationManager:add_localized_strings({
			ca_default_value = "静物色差",
			ca_default_value_desc = "色差效果应用到物体边缘上的默认数值",
			ca_duration = "持续时间",
			ca_duration_desc = "受击色差效果的持续时间",
			ca_amount = "效果幅度",
			ca_amount_desc = "受击色差效果的表现幅度",
			ca_on_suppression = "压制",
			ca_on_armor_damage = "护甲伤害",
			ca_on_health_damage = "血量伤害",
			ca_on_suppression_desc = "受敌人压制时触发效果",
			ca_on_armor_damage_desc = "受护甲伤害时触发效果",
			ca_on_health_damage_desc = "受血量伤害时触发效果",
		})
	 elseif Idstring("spanish"):key() == SystemInfo:language():key() or Idstring("latam"):key() == SystemInfo:language():key()then
        LocalizationManager:add_localized_strings({
			ca_default_value = "Aberración cromática estática",
			ca_default_value_desc = "Establecer la cantidad de aberración cromática estática en pantalla",
            ca_duration = "Duración",
            ca_duration_desc = "Establecer la duración del efecto de aberración cromática al recibir golpes",
            ca_amount = "Cantidad",
            ca_amount_desc = "Establecer la cantidad de aberración cromática generada al recibir golpes",
            ca_on_suppression = "Fuego de supresión",
            ca_on_armor_damage = "Daño al blindaje",
            ca_on_health_damage = "Daño a la salud",
            ca_on_suppression_desc = "Activar / desactivar el efecto de aberración cromática cuando los enemigos te disparen",
            ca_on_armor_damage_desc = "Activar / desactivar el efecto de aberración cromática al recibir daño al blindaje",
            ca_on_health_damage_desc = "Activar / desactivar el efecto de aberración cromática al recibir daño a la salud",
        })
	elseif Idstring("russian"):key() == SystemInfo:language():key() then
		LocalizationManager:add_localized_strings({
			ca_default_value = "Статичная аберрация",
			ca_default_value_desc = "Default amount of abberation on the screen.",
			ca_duration = "Продолжительность",
			ca_duration_desc = "Продолжительность вспышки.",
			ca_amount = "Ширина",
			ca_amount_desc = "Ширина вспышки.",
			ca_on_suppression = "Подавление",
			ca_on_armor_damage = "Урон брони",
			ca_on_health_damage = "Урон здоровья",
			ca_on_suppression_desc = "Вспышка при подавляющем огне противника.",
			ca_on_armor_damage_desc = "Вспышка при получении урона по броне.",
			ca_on_health_damage_desc = "Вспышка при получении урона по здоровью.",
		})
	   end
end)

_G.CA_HitFlash = _G.CA_HitFlash or {}
CA_HitFlash._mod_path = CA_HitFlash._mod_path or ModPath
CA_HitFlash._setting_path = SavePath .. "ca_hit_flash.json"
CA_HitFlash.settings = CA_HitFlash.settings or {}
function CA_HitFlash:Save()
	local file = io.open(self._setting_path, "w+")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

function CA_HitFlash:Load()
	local file = io.open(self._setting_path, "r")
	if file then
		for k, v in pairs(json.decode(file:read("*all")) or {}) do
			self.settings[k] = v
		end
		file:close()
	else
		self.settings = {
			ca_default_value = 0.15,
			ca_amount = 8,
			ca_duration = 0.8,
			on_suppression = false,
			on_armor_damage = true,
			on_health_damage = true
		}
		self:Save()
	end
end

Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_CA_HitFlash", function(...)
	CA_HitFlash:Load()
	MenuHelper:LoadFromJsonFile(CA_HitFlash._mod_path .. "options.json", CA_HitFlash, CA_HitFlash.settings)
	managers.environment_controller:set_base_chromatic_amount(CA_HitFlash.settings.ca_default_value or 0.15)
end)

Hooks:Add("MenuManagerBuildCustomMenus", "MenuManagerBuildCustomMenusCA_HitFlash", function(menu_manager, nodes)
	function MenuCallbackHandler:set_ca_default_value_callback(item)
		managers.environment_controller:set_base_chromatic_amount(tonumber(item:value()))
		CA_HitFlash.settings.ca_default_value = tonumber(item:value())
		CA_HitFlash:Save()
	end
	
	function MenuCallbackHandler:set_ca_duration_callback(item)
		CA_HitFlash.settings.ca_duration = tonumber(item:value())
		CA_HitFlash:Save()
	end
	
	function MenuCallbackHandler:set_ca_amount_callback(item)
		CA_HitFlash.settings.ca_amount = tonumber(item:value())
		CA_HitFlash:Save()
	end
	
	local function add_toggle(name, menu_id, pos)
		MenuCallbackHandler["ca_"..name.."_callback"] = function(self, item)
			CA_HitFlash.settings[name] = item:value() == "on" and true or false
			CA_HitFlash:Save()
		end
		
		MenuHelper:AddToggle({
			id = name,
			title = "ca_"..name,
			desc = "ca_"..name.."_desc",
			callback = "ca_"..name.."_callback",
			value = CA_HitFlash.settings[name],
			menu_id = menu_id,
			priority = 2
		})
	end

	local menu_id = "ca_hitflash_options"
	MenuHelper:NewMenu(menu_id)

	MenuHelper:AddSlider({
		id = "ca_default_value",
		title = "ca_default_value",
		desc = "ca_default_value_desc",
		callback = "set_ca_default_value_callback",
		value = CA_HitFlash.settings.ca_default_value,
		max = 1,
		min = 0,
		step = 0.1,
		show_value = true,
		menu_id = menu_id,
		priority = 1.5
	})
	
	MenuHelper:AddSlider({
		id = "ca_amount",
		title = "ca_amount",
		desc = "ca_amount_desc",
		callback = "set_ca_amount_callback",
		value = CA_HitFlash.settings.ca_amount,
		max = 10,
		min = 2,
		step = 1,
		show_value = true,
		menu_id = menu_id,
		priority = 1
	})
	
	MenuHelper:AddSlider({
		id = "ca_duration",
		title = "ca_duration",
		desc = "ca_duration_desc",
		callback = "set_ca_duration_callback",
		value = CA_HitFlash.settings.ca_duration,
		max = 3,
		min = 0.5,
		step = 0.1,
		show_value = true,
		menu_id = menu_id
	})
	
	add_toggle("on_health_damage", menu_id)
	add_toggle("on_armor_damage", menu_id)
	add_toggle("on_suppression", menu_id)

	nodes[menu_id] = MenuHelper:BuildMenu(menu_id)

	MenuHelper:AddMenuItem(nodes["blt_options"], menu_id, "menu_ca_hitflash")
end)