local timer = 0
local hf = CA_HitFlash.settings
local function ratio(max, val)
	return max ~= 0 and val / max or 0
end

Hooks:PostHook(PlayerDamage, "build_suppression", "CA_HitFlash_trigger_on_suppression", function()
	if hf.on_suppression then
		timer = hf.ca_duration
	end
end)

Hooks:PostHook(PlayerDamage, "_call_listeners", "CA_HitFlash_trigger_on_damage", function(self)
	if hf.on_armor_damage and self:armor_ratio() > 0 then
		timer = hf.ca_duration
	end
	
	if hf.on_health_damage and self:armor_ratio() == 0 then
		timer = hf.ca_duration
	end
end)

Hooks:PostHook(PlayerDamage, "update", "CA_HitFlash_timer", function(self, unit, t, dt)
	local default_value = CA_HitFlash.settings.ca_default_value or 0.15
	if timer >= 0 then
		timer = timer - dt
		local amount = hf.ca_amount * ratio(hf.ca_duration, timer)
		managers.environment_controller:set_base_chromatic_amount(amount > default_value and amount or default_value)
	end
end)

Hooks:PostHook(PlayerDamage, "on_downed", "CA_HitFlash_on_downed", function()
	managers.environment_controller:set_base_chromatic_amount(CA_HitFlash.settings.ca_default_value or 0.15)
end)